<?php

namespace Drupal\vc_actions_volunteer\Access;

use Drupal\Core\Routing\Access\AccessInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Routing\RouteMatchInterface;
use Symfony\Component\Routing\Route;

/**
 * Class NewVolunteer
 * @package Drupal\vc_actions_volunteer\Access
 */
class NewVolunteer implements AccessInterface {

  /**
   * @param Route $route
   * @param RouteMatchInterface $route_match
   * @param AccountInterface $account
   * @return AccessResult|\Drupal\Core\Access\AccessResultAllowed
   */
  public function access(Route $route, RouteMatchInterface $route_match, AccountInterface $account) {
    $vc_need = $route_match->getParameter('vc_need');
    $query = \Drupal::entityQuery('vc_action');
    $query->condition('type', 'volunteer_action');
    $query->condition('field_need', $vc_need->id());
    $query->condition('field_volunteer', \Drupal::currentUser()->id());
    $query->condition('status', 1);
    $result = $query->execute();
    if (empty($result)) {
      return AccessResult::allowedIfHasPermission($account,'vc_actions_volunteer volunteer for need');
    }
    return AccessResult::forbidden();
  }
}
